/* ****************************************************
PROCEDIMENTS MODUL ESTADSTIC - REF.Enunciat_TFC_BDR_201302 AP.8

@Nom:				ins_act_EST_81
@Funcionalitat:		Actualitza el nmero total de jugadors en actiu en tots els gneres i modalitats.
@params IN:		paramGenere VARCHAR2(7 CHAR), 
				paramModalitat VARCHAR2(15 CHAR),
				paramOp CHAR(1),
@params OUT:	paramEntrada VARCHAR2(512),
				procediment VARCHAR2(24);
				text VARCHAR2(512);
				RSP
@error			MSG_ERR amb imformaci de l'error
**************************************************** */  
create or replace PROCEDURE act_EST_81 
(
  paramGenere		IN VARCHAR2, 
  paramModalitat	IN VARCHAR2, 
  paramOP			IN CHAR,
  
  RSP 			OUT NOCOPY VARCHAR2
)
AS

  paramEntrada	VARCHAR2(512);
  procediment   VARCHAR2(24);
  text		VARCHAR2(512);
   
  ERR_NUM	NUMBER(6);  
  MSG_ERR	VARCHAR2(56);
 
  existeix INTEGER;
 
BEGIN
RSP := 'KO';
procediment := 'act_EST_81'; 
paramEntrada := 'Genere: ' || paramGenere || 
          ' - Modalitat: ' || paramModalitat ||
          ' - Operaci: ' || paramOp;	

-- Comprova si hi ha cap registre segon gnere i modalitat
SELECT count(*) INTO existeix
FROM EST_81
WHERE genere = paramGenere
	AND modalitat = paramModalitat ;

IF (existeix = 1 AND paramOp = '+') THEN
	UPDATE EST_81 SET jugadors = jugadors + 1
	WHERE genere = paramGenere AND modalitat = paramModalitat ;
  ELSIF (existeix = 1 AND paramOp = '-') THEN 
	UPDATE EST_81 SET jugadors = jugadors - 1
	WHERE genere = paramGenere AND modalitat = paramModalitat ;
  ELSIF (existeix = 0) THEN
	INSERT INTO EST_81 VALUES (paramGenere, paramModalitat, 1) ;
END IF;
    
RSP:='OK';
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);   
       
  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;  
      MSG_ERR := SQLERRM;  
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);
    
END act_EST_81 ;
/
