/* ****************************************************
PROCEDIMENTS MODUL ESTADSTIC - REF.Enunciat_TFC_BDR_201302 AP.8

@Nom:				act_EST_82
@Funcionalitat:		Actualitza i emmmagatzema el mxim anotador per competici de la temporada actual.
@params IN:		paramCompeticio NUMBER,				
@params OUT:	paramEntrada VARCHAR2(512),
				procediment VARCHAR2(24);
				text VARCHAR2(512);
				RSP
@error			MSG_ERR amb imformaci de l'error
**************************************************** */  
create or replace PROCEDURE act_EST_82
(
  paramCompeticio	IN NUMBER, 
  
  RSP 			OUT NOCOPY VARCHAR2
)
AS

  paramEntrada	VARCHAR2(512);
  procediment   VARCHAR2(24);
  text		VARCHAR2(512);
   
  ERR_NUM	NUMBER(6);  
  MSG_ERR	VARCHAR2(56);
 
  existeix INTEGER;
  varNom VARCHAR2(20);
  varCognom VARCHAR2(20);
  varJugador VARCHAR2(40);
  varCompeticio VARCHAR2(30);
  varPunts NUMBER;
  varTemporada VARCHAR2(9);
 
BEGIN
RSP := 'KO';
procediment := 'act_EST_82'; 
paramEntrada := 'Competicio: ' || paramCompeticio ;	

-- cerca temporada actual:
SELECT MAX(id_temporada) INTO varTemporada
FROM TEMPORADA;

-- cerca el mxim anotador de la temporada actual:
SELECT nom, cognom, punts INTO varNom, varCognom, varPunts
FROM (
  SELECT j.nom AS nom, j.cognom1 AS cognom, SUM(p.pt) AS punts
  FROM JUGADOR j, PARTICIPA p, PARTIT t, NACIONAL n
  WHERE j.id_jugador = p.jugador
    AND p.partit = t.id_partit
    AND t.competicio = n.id_competicio
  HAVING SUM(p.pt) = (SELECT MAX(acumulat)
                FROM (SELECT SUM(p.PT) AS acumulat
					FROM JUGADOR j, PARTICIPA p, PARTIT t, NACIONAL n
					WHERE j.id_jugador = p.jugador
					AND p.partit = t.id_partit
					AND t.competicio = n.id_competicio
				  AND n.temporada = varTemporada
					AND n.id_competicio = paramCompeticio
					group by j.id_jugador)
					)
  GROUP BY j.nom, j.cognom1
) WHERE ROWNUM = 1;

-- quin s el nom de la competici?
SELECT nom INTO varCompeticio
FROM COMPETICIO
WHERE id_competicio = paramCompeticio;

-- quin s el nom del mxim anotador?
varJugador := varNom || ' ' || varCognom;

-- Comprova si hi ha cap registre de la competici:
SELECT count(*) INTO existeix
FROM EST_82
WHERE competicio = varCompeticio;

IF (existeix = 0) THEN 
	INSERT INTO EST_82 VALUES (varCompeticio, varJugador, varPunts) ;
ELSIF (existeix = 1) THEN
	UPDATE EST_82 SET jugador = varJugador, punts = varPunts
	WHERE competicio = varCompeticio ;
END IF;
    
RSP:='OK';
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);   
       
  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;  
      MSG_ERR := SQLERRM;  
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);
    
END act_EST_82 ;
/
