/* ****************************************************
PROCEDIMENTS MODUL ESTADSTIC - REF.Enunciat_TFC_BDR_201302 AP.8

@Nom:				rsp_EST_82
@Funcionalitat:		Retorna el jugador amb ms punts en una competici.
@params IN:		paramCompeticio NUMBER,
				paramTemporada VARCHAR2(9),
@params OUT:	paramEntrada VARCHAR2(512),
				procediment VARCHAR2(24);
				text VARCHAR2(512);
				RSP
@error			MSG_ERR amb imformaci de l'error
**************************************************** */  
create or replace PROCEDURE rsp_EST_82
(
  paramCompeticio	IN EST_82.competicio%TYPE, 
     
  RSP 			OUT NOCOPY VARCHAR2
)
AS

  paramEntrada	VARCHAR2(512);
  procediment   VARCHAR2(24);
  text		VARCHAR2(512);
   
  ERR_NUM	NUMBER(6);  
  MSG_ERR	VARCHAR2(56);
 
  existeix INTEGER;
  varJugador VARCHAR2(40);
  varPunts NUMBER;
 
BEGIN
RSP := 'KO';
text := '';
procediment := 'rsp_EST_82'; 
paramEntrada := 'Competici: ' || paramCompeticio ;

-- Comprova si hi ha cap registre de la competici:
SELECT count(*) INTO existeix
FROM EST_82
WHERE competicio = paramCompeticio ;

IF (existeix = 1) THEN
	SELECT jugador, punts INTO varJugador, varPunts
	FROM EST_82 
	WHERE competicio = paramCompeticio;

	text := 'Competici: ' || paramCompeticio || 
          ' - Jugador: ' || varJugador ||	
          ' - Punts: ' || varPunts ;	

  ELSIF (existeix = 0) THEN
	text := 'No hi ha registres per a aquesta selecci.';
END IF;
    
RSP:='OK' || ' - ' || text;
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);  
       
  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;  
      MSG_ERR := SQLERRM;  
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);
    
END rsp_EST_82 ;
/
