/* ****************************************************
PROCEDIMENTS MODUL ESTADSTIC - REF.Enunciat_TFC_BDR_201302 AP.8

@Nom:				act_EST_83
@Funcionalitat:		Emmagatzema el jugador ms ben pagat de cada modalitat i gnere.
@params IN:		paramModalitat VARCHAR2(15),
				paramGenere VARCHAR2(1),
				paramJugador NUMBER, 
				paramSalari NUMBER,
@params OUT:	paramEntrada VARCHAR2(512),
				procediment VARCHAR2(24);
				text VARCHAR2(512);
				RSP
@error			MSG_ERR amb imformaci de l'error
**************************************************** */  
create or replace PROCEDURE act_EST_83
(
  paramModalitat	IN VARCHAR2, 
  paramGenere		IN VARCHAR2, 
  paramJugador		IN NUMBER, 
  paramSalari		IN NUMBER,  
  
  RSP 			OUT NOCOPY VARCHAR2
)
AS

  paramEntrada	VARCHAR2(512);
  procediment   VARCHAR2(24);
  text		VARCHAR2(512);
   
  ERR_NUM	NUMBER(6);  
  MSG_ERR	VARCHAR2(56);
 
  existeix INTEGER;
  varNom VARCHAR2(20);
  varCognom VARCHAR2(20);
  varJugador VARCHAR2(40);  
  varSalari NUMBER;
 
BEGIN
RSP := 'KO';
procediment := 'act_EST_83'; 
paramEntrada := 'Modalitat: ' || paramModalitat ||
          ' - Genere: ' || paramGenere || 
          ' - Jugador: ' || paramJugador ||
          ' - Salari mxim: ' || paramSalari ;	

-- cerca el nom del jugador:
SELECT nom, cognom1 INTO varNom, varCognom
FROM JUGADOR
WHERE id_jugador = paramJugador;

varJugador := varNom || ' ' || varCognom;

-- Comprova si hi ha cap registre segon modalitat i gnere
SELECT count(*) INTO existeix
FROM EST_83
WHERE modalitat = paramModalitat
	AND genere = paramGenere ;

IF (existeix = 0) THEN 
	INSERT INTO EST_83 VALUES (paramModalitat, paramGenere, paramJugador, paramSalari) ;
ELSIF (existeix = 1) THEN
	SELECT max(sou) INTO varSalari
	FROM EST_83
	WHERE modalitat = paramModalitat
		AND genere = paramGenere;

	IF (paramSalari > varSalari) THEN
		UPDATE EST_83 SET jugador = varJugador, sou = paramSalari
		WHERE modalitat = paramModalitat
			AND genere = paramGenere;
	END IF;
END IF;
    
RSP:='OK';
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);   
       
  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;  
      MSG_ERR := SQLERRM;  
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);
    
END act_EST_83 ;
/
