/* ****************************************************
PROCEDIMENTS MODUL ESTADSTIC - REF.Enunciat_TFC_BDR_201302 AP.8

@Nom:				act_EST_84
@Funcionalitat:		Emmagatzema el jugador ms guanys al llarg de la seva carrera, a la taula EST_84.
@params IN:		
@params OUT:	paramEntrada VARCHAR2(512),
				procediment VARCHAR2(24);
				text VARCHAR2(512);
				RSP
@error			MSG_ERR amb imformaci de l'error
**************************************************** */  
create or replace PROCEDURE act_EST_84
(
  RSP 			OUT NOCOPY VARCHAR2
)
AS

  paramEntrada	VARCHAR2(512);
  procediment   VARCHAR2(24);
  text		VARCHAR2(512);
   
  ERR_NUM	NUMBER(6);  
  MSG_ERR	VARCHAR2(56);
 
  existeix INTEGER;
  varNom VARCHAR2(20);
  varCognom VARCHAR2(20);
  varJugador VARCHAR2(40);
  varAcumulat NUMBER;
   
BEGIN
RSP := 'KO';
procediment := 'act_EST_84'; 
paramEntrada := '' ;	

-- cerca el jugador amb ms guanya acumulats:
SELECT j.nom, j.cognom1, SUM(c.salariBrut) INTO varNom, varCognom, varAcumulat
FROM JUGADOR j INNER JOIN CONTRACTE c ON c.jugador = j.id_jugador
HAVING SUM(c.salariBrut) = (SELECT MAX(acumulat)
                FROM (SELECT SUM(salariBrut)AS acumulat
                FROM CONTRACTE
                group by jugador))
GROUP BY j.nom, j.cognom1;

-- quin s el nom el jugador?
varJugador := varNom || ' ' || varCognom;
		  
-- Comprova si hi ha cap registre a la taula EST_84:
SELECT count(*) INTO existeix
FROM EST_84;

IF (existeix = 0) THEN 
	INSERT INTO EST_84 VALUES (varJugador, varAcumulat) ;
  ELSIF (existeix = 1) THEN
  DELETE FROM EST_84;
  INSERT INTO EST_84 VALUES (varJugador, varAcumulat) ;
	--UPDATE EST_84 SET jugador = varJugador, guanysAcumulats = varAcumulat;
END IF;
    
RSP:='OK';
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);  
       
  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;  
      MSG_ERR := SQLERRM;  
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);
    
END act_EST_84 ;
/
