/* ****************************************************
PROCEDIMENTS MODUL ESTADSTIC - REF.Enunciat_TFC_BDR_201302 AP.8

@Nom:				rsp_EST_85
@Funcionalitat:		Donat un pas, una temporada, un gnere i una modalitat, retorna el sou mig anual dels jugadors.
@params IN:		paramPais VARCHAR2(20 CHAR),
				paramTemporada VARCHAR2(9 CHAR),
				paramGenere VARCHAR2(7 CHAR), 
				paramModalitat VARCHAR2(15 CHAR),
@params OUT:	paramEntrada VARCHAR2(512),
				procediment VARCHAR2(24);
				text VARCHAR2(512);
				RSP
@error			MSG_ERR amb imformaci de l'error
**************************************************** */  
create or replace PROCEDURE rsp_EST_85 
(
  paramPais   IN EST_85.pais%TYPE,  
  paramTemporada  IN EST_85.temporada%TYPE,  
  paramGenere		IN EST_85.genere%TYPE,  
  paramModalitat		IN EST_85.modalitat%TYPE,
   
  RSP 			OUT NOCOPY VARCHAR2
)
AS

  paramEntrada	VARCHAR2(512);
  procediment   VARCHAR2(24);
  text		VARCHAR2(512);
   
  ERR_NUM	NUMBER(6);  
  MSG_ERR	VARCHAR2(56);
 
  existeix INTEGER;
  varVP	NUMBER;

BEGIN
RSP := 'KO';
text := '';
procediment := 'rsp_EST_85'; 
paramEntrada := 'Pais: ' || paramPais ||
          ' - Temporada: ' || paramTemporada || 
          ' - Gnere: ' || paramGenere ||          
          ' - Modalitat: ' || paramModalitat ;	

-- Comprova si hi ha cap registre segons parmetres d'entrada:
SELECT count(*) INTO existeix
FROM EST_85
	WHERE pais = paramPais
    AND temporada = paramTemporada
    AND genere = paramGenere
		AND modalitat = paramModalitat;

IF (existeix = 1) THEN
	SELECT ROUND(souMig,2) INTO varVP 
 	FROM EST_85 
	WHERE pais = paramPais
    AND temporada = paramTemporada
    AND genere = paramGenere
		AND modalitat = paramModalitat;

	text := 'Pais: ' || paramPais || 
          ' - Temporada: ' || paramTemporada || 
          ' - Gnere: ' || paramGenere || 
          ' - Modalitat: ' || paramModalitat ||
          ' - Valor ' || varVP;	

  ELSIF (existeix = 0) THEN
	text := 'No hi ha registres per a aquesta selecci.';  
END IF;
    
RSP:='OK' || ' - ' || text;
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR); 
       
  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;  
      MSG_ERR := SQLERRM;  
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);
    
END rsp_EST_85 ;
/
