/* ****************************************************
PROCEDIMENTS MODUL ESTADSTIC - REF.Enunciat_TFC_BDR_201302 AP.8

@Nom:				act_EST_86
@Funcionalitat:		Donada una competici i una temporada, emmagatzema els millors equips ofensius i defensius, a la taula EST_86.
@params IN:		paramCompeticio NUMBER, 
				paramTemporada	VARCHAR2(9)
@params OUT:	paramEntrada VARCHAR2(512),
				procediment VARCHAR2(24);
				text VARCHAR2(512);
				RSP
@error			MSG_ERR amb imformaci de l'error
**************************************************** */  
create or replace PROCEDURE act_EST_86
(
  paramCompeticio	IN NUMBER,
  paramTemporada	IN EST_86.temporada%TYPE,

  RSP 			OUT NOCOPY VARCHAR2
)
AS
  paramEntrada	VARCHAR2(512);
  procediment   VARCHAR2(24);
  text		VARCHAR2(512);

  ERR_NUM	NUMBER(6);
  MSG_ERR	VARCHAR2(56);

  existeix	INTEGER;
  varOf	NUMBER;
  varDef	NUMBER;
  varEqOf	VARCHAR2(25);
  varEqDef	VARCHAR2(25);
  varCompeticio VARCHAR2(30);

BEGIN
RSP := 'KO';
procediment := 'act_EST_86';
paramEntrada := 'Competici: ' || paramCompeticio ||
          ' - Temporada: ' || paramTemporada ;

-- quin nom t la competici?
SELECT nom INTO varCompeticio
FROM COMPETICIO
WHERE id_competicio = paramCompeticio;
DBMS_OUTPUT.PUT_LINE(VARCOMPETICIO);
-- Comprova si hi ha cap registre segon els parmetres d'entrada:
SELECT count(*) INTO existeix
FROM EST_86
WHERE competicio = varCompeticio
	AND temporada = paramTemporada;
 
-- cerca el millor equip ofensiu:
SELECT nom, valor INTO varEqOf, varOf
FROM
(
  SELECT e.nom AS nom, SUM(p.PT + p.T1E + p.T2E + p.T3E + p.RO + p.ASS + p.FR - p.T1I - p.T2I - p.T3I - p.TC - p.PP) AS valor
  FROM PARTICIPA p INNER JOIN PARTIT t ON p.partit = t.id_partit
		INNER JOIN EQUIP e ON (e.id_equip = t.eqLocal OR e.id_equip = t.eqVisitant)
		INNER JOIN NACIONAL n ON t.competicio = n.id_competicio
  HAVING SUM(p.PT + p.T1E + p.T2E + p.T3E + p.RO + p.ASS + p.FR - p.T1I - p.T2I - p.T3I - p.TC - p.PP) = (SELECT MAX(acumulat)
                FROM (SELECT SUM(p.PT + p.T1E + p.T2E + p.T3E + p.RO + p.ASS + p.FR - p.T1I - p.T2I - p.T3I - p.TC - p.PP) AS acumulat
                FROM PARTICIPA p INNER JOIN PARTIT t ON p.partit = t.id_partit
				INNER JOIN EQUIP e ON (e.id_equip = t.eqLocal OR e.id_equip = t.eqVisitant)
				INNER JOIN NACIONAL n ON t.competicio = n.id_competicio
				WHERE n.id_competicio = paramCompeticio
					AND n.temporada = paramTemporada
                group by e.nom)
				)
  GROUP BY e.nom
) WHERE ROWNUM = 1;
 
-- cerca el millor equip defensiu:
SELECT nom2, valor2 INTO varEqDef, varDef
FROM
(
  SELECT e.nom AS nom2, SUM(p.RD + p.TF + p.PR - p.FC) AS valor2
  FROM PARTICIPA p INNER JOIN PARTIT t ON p.partit = t.id_partit
		INNER JOIN EQUIP e ON (e.id_equip = t.eqLocal OR e.id_equip = t.eqVisitant)
		INNER JOIN NACIONAL n ON t.competicio = n.id_competicio
  HAVING SUM(p.RD + p.TF + p.PR - p.FC) = (SELECT MAX(acumulat)
                FROM (SELECT SUM(p.RD + p.TF + p.PR - p.FC) AS acumulat
                FROM PARTICIPA p INNER JOIN PARTIT t ON p.partit = t.id_partit
				INNER JOIN EQUIP e ON (e.id_equip = t.eqLocal OR e.id_equip = t.eqVisitant)
				INNER JOIN NACIONAL n ON t.competicio = n.id_competicio
				WHERE n.id_competicio = paramCompeticio
					AND n.temporada = paramTemporada
                group by e.nom)
				)
  GROUP BY e.nom
) WHERE ROWNUM = 1;

-- si el registre existeix, actualitza dades del registre: nom equip i/ valoraci.
IF (existeix = 1) THEN
	UPDATE EST_86 SET EquipOf = varEqOf, EquipDef = varEqDef, valorOf = varOf, valorDef = varDef
	WHERE competicio = varCompeticio
		AND temporada = paramTemporada;
DBMS_OUTPUT.PUT_LINE('3contr: ' || existeix);
-- si no hi ha cap registre previ, es crea el registre amb les dades del primer equip avaluat:
ELSIF (existeix=0) THEN
	INSERT INTO EST_86 VALUES(varCompeticio, paramTemporada, varEqOf, varOf, varEqDef, varDef);
END IF;
DBMS_OUTPUT.PUT_LINE('4contr: ' || existeix);

RSP:='OK';
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR); 

  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;
      MSG_ERR := SQLERRM;
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);

END act_EST_86 ;
/
