/* ****************************************************
PROCEDIMENTS MODUL ESTADSTIC - REF.Enunciat_TFC_BDR_201302 AP.8

@Nom:				rsp_EST_86
@Funcionalitat:		Donada una competici i una temporada, retorna els millors equips ofensiu i defensiu.
@params IN:		paramCompeticio NUMBER, 
				paramTemporada VARCHAR2(9 CHAR),				
@params OUT:	paramEntrada VARCHAR2(512),
				procediment VARCHAR2(24);
				text VARCHAR2(512);
				RSP
@error			MSG_ERR amb imformaci de l'error
**************************************************** */  
create or replace PROCEDURE rsp_EST_86 
(
  paramCompeticio	IN	EST_86.competicio%TYPE, 
  paramTemporada	IN 	EST_86.temporada%TYPE, 
   
  RSP 			OUT NOCOPY VARCHAR2
)
AS

  paramEntrada	VARCHAR2(512);
  procediment   VARCHAR2(24);
  text		VARCHAR2(512);
   
  ERR_NUM	NUMBER(6);  
  MSG_ERR	VARCHAR2(56);
 
  existeix INTEGER;
  varOf	NUMBER;
  varDef	NUMBER;
  varEqOf	VARCHAR2(25);
  varEqDef	VARCHAR2(25);
 
BEGIN
RSP := 'KO';
text := '';
procediment := 'rsp_EST_86'; 
paramEntrada := 'Competicio: ' || paramCompeticio || 
          ' - Temporada: ' || paramTemporada ;	

-- Comprova si hi ha cap registre segons parmetres d'entrada:
SELECT count(*) INTO existeix
FROM EST_86
WHERE competicio = paramCompeticio
	AND temporada = paramTemporada ;

IF (existeix = 1) THEN
	SELECT equipOf, valorOf, equipDef, valorDef 
	INTO varEqOf, varOf, varEqDef, varDef
 	FROM EST_86 
	WHERE competicio = paramCompeticio AND temporada = paramTemporada ;

	text := 'Competicio: ' || paramCompeticio || 
          ' - Temporada: ' || paramTemporada ||	
          ' - Millor equip ofensiu: ' || varEqOf || ' - ' || varOf || 
          ' - Millor equip ofensiu: ' || varEqDef || ' - ' || varDef;	

  ELSIF (existeix = 0) THEN
	text := 'No hi ha registres per a aquesta selecci.';
END IF;
    
RSP:='OK' || ' - ' || text;
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR); 
       
  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;  
      MSG_ERR := SQLERRM;  
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);
    
END rsp_EST_86 ;
/
