/* ****************************************************
PROCEDIMENTS MODUL ESTADSTIC - REF.Enunciat_TFC_BDR_201302 AP.8

@Nom:				rsp_EST_87
@Funcionalitat:		Donats un gnere i una modalitat, retorna el millor jugador de la temporada passada.
@params IN:		paramGenere VARCHAR2(1 CHAR),
				paramModalitat VARCHAR2(15 CHAR),
@params OUT:	paramEntrada VARCHAR2(512),
				procediment VARCHAR2(24);
				text VARCHAR2(512);
				RSP
@error			MSG_ERR amb imformaci de l'error
**************************************************** */  
create or replace PROCEDURE rsp_EST_87 
(
  paramGenere		IN EST_87.genere%TYPE,  
  paramModalitat	IN EST_87.modalitat%TYPE,  
   
  RSP 			OUT NOCOPY VARCHAR2
)
AS

  paramEntrada	VARCHAR2(512);
  procediment   VARCHAR2(24);
  text		VARCHAR2(512);
   
  ERR_NUM	NUMBER(6);  
  MSG_ERR	VARCHAR2(56);
 
  existeix INTEGER;
  varJugador VARCHAR2(40);
  varVP	NUMBER;

BEGIN
RSP := 'KO';
text := '';
procediment := 'rsp_EST_87'; 
paramEntrada := 'Gnere: ' || paramGenere ||          
          ' - Modalitat: ' || paramModalitat ;	

-- Comprova si hi ha cap registre segons parmetres d'entrada:
SELECT count(*) INTO existeix
FROM EST_87
WHERE genere = paramGenere
	AND modalitat = paramModalitat ;

IF (existeix = 1) THEN
	SELECT millorJugador, valorMig INTO varJugador, varVP 
 	FROM EST_87 
	WHERE genere = paramGenere
		AND modalitat = paramModalitat;

	text := 'Gnere: ' || paramGenere || 
          ' - Modalitat: ' || paramModalitat || 
          ' - Jugador: ' || varJugador || 
          ' - Valor ' || varVP;	

  ELSIF (existeix = 0) THEN
	text := 'No hi ha registres per a aquesta selecci.';
END IF;
    
RSP:='OK' || ' - ' || text;
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR); 
       
  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;  
      MSG_ERR := SQLERRM;  
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);
    
END rsp_EST_87 ;
/