/* ****************************************************
PROCEDIMENTS ABM - REF.Enunciat_TFC_BDR_201302 AP.7

@Nom:	slt_7B
@Funcionalitat:	Retorna un llistat de tots els equips d'una competicio ordenats pel nombre  de punts totals a favor en la temporada actual.
@params IN:	paramCompeticio NUMBER,
@params OUT:	paramEntrada VARCHAR2(512),
	procediment VARCHAR2(24);
	text VARCHAR2(512);
	RSP
@error	MSG_ERR amb imformaci de l'error
**************************************************** */ 
create or replace PROCEDURE slt_7B 
(
  paramCompeticio	IN NUMBER,
  RSP	OUT NOCOPY VARCHAR2
)
AS

  paramEntrada	VARCHAR2(512);
  procediment	VARCHAR2(24);
  text	VARCHAR2(512);
   
  ERR_NUM	NUMBER(6);
  ERR_NN	EXCEPTION;
  ERR_EX	EXCEPTION;

  MSG_ERR	VARCHAR2(56);
  MSG_NN	VARCHAR2(25);
  MSG_EX	VARCHAR2(25);
  
  existeix	NUMBER;
  
  varCompeticio	VARCHAR2(20);
  varEquip	VARCHAR2(20);
  varPunts	NUMBER;

  CURSOR cursor_B IS
  SELECT c.nom AS COMPETICIO, e.nom AS EQUIP, cl.punts AS PUNTS  
  FROM CLASSIFICACIO cl, COMPETICIO c, EQUIP e
  WHERE cl.competicio = c.id_competicio
	AND cl.equip = e.id_equip
	AND cl.competicio= paramCompeticio
	-- i la temporada
  ORDER BY cl.punts;
     
BEGIN
RSP := 'KO';
procediment := 'sel_7B'; 
paramEntrada := 'Competici: ' || paramCompeticio;	

-- comprovar dades d'entrada:   
	IF (paramCompeticio IS NULL) THEN
		MSG_NN := 'Cal emplenar el camp NOM.';
		RAISE ERR_NN;
	END IF;
	
-- comprovar si existeix la competicio:
	SELECT id_competicio INTO existeix
	FROM COMPETICIO
	WHERE id_competicio = paramCompeticio;
	
	IF (existeix = 0) THEN
		MSG_EX := 'La competicio ' || paramCompeticio || ' no existeix a taula POSICIO de la BD.';
		RAISE ERR_EX;
	END IF;

-- crida i procs del cursor:
OPEN cursor_B;

loop 
	FETCH cursor_B INTO varCompeticio, varEquip, varPunts;
	EXIT WHEN cursor_B%notfound;
	
	--tractament de la sortida:
	DBMS_OUTPUT.PUT_LINE(varCompeticio || ',' || varEquip || ',' || varPunts);
END LOOP;

-- tanca el cursor
CLOSE cursor_B;

RSP:='OK' || '-' || text;
INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || RSP || ' - ' || Procediment  || ' - ' || paramEntrada);
DBMS_OUTPUT.PUT_LINE(RSP);
    
  EXCEPTION
  WHEN NO_DATA_FOUND THEN
    ERR_NUM := -20008;   
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS')
		|| ' - ' || paramEntrada || ' - ' || procediment || ' - ' || RSP);
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);    

  WHEN ERR_NN THEN
    MSG_ERR := MSG_NN;
    text := (RSP || ' - ' || Procediment  || ' - ' || paramEntrada || ' - ' || MSG_ERR);
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS') || ' - ' || text );
    DBMS_OUTPUT.PUT_LINE(RSP || ' - ' || Procediment || ' - ' || MSG_ERR);

  WHEN ERR_EX THEN
    MSG_ERR := MSG_EX;
    text := (RSP || ' - ' || Procediment  || ' - ' || paramEntrada || ' - ' || MSG_ERR);
      INSERT INTO LOG VALUES(to_char(sysdate, 'DD-MM-YYYY HH24:MI:SS') || ' - ' || text );
 	DBMS_OUTPUT.PUT_LINE(RSP || ' - ' || Procediment || ' - ' || MSG_ERR);
    
  WHEN OTHERS THEN
      ERR_NUM := SQLCODE;  
      MSG_ERR := SQLERRM;  
      DBMS_OUTPUT.PUT_LINE('Error: ' || TO_CHAR(ERR_NUM) || ', ' || MSG_ERR);
    
END slt_7B;
/